package Xchat::nocturne::NocHighlight;

use warnings;
use strict;
use Tie::File;                                                         

##############################################
## NocHighlight v. 1.0                      ##
## ---------------------------------------- ##
## Show in the active window any            ##
## highlighted message from other channels  ##
##############################################
## Aris Agrippas, Copyright (c) 2007        ##
## GNU general public licence               ##
##############################################

my ($name, $version) = ('nochighlight', '1.0');   
Xchat::register($name, $version, 'Highlighted text on active window', '');
																		  
Xchat::hook_print('Channel Msg Hilight', 'show_Msg', {data => 'msg'});
Xchat::hook_print('Channel Action Hilight', 'show_Msg', {data => 'me'});

sub is_Active_Window{
	my $current_window = Xchat::find_context();
	my $hilight_window = Xchat::find_context(shift);
	return 1 if ($current_window == $hilight_window);
	return 0;
}

sub is_Script_Window{
	return 1 if (substr(shift,0,1) =~ /:/);
	return 0;
}


sub show_Msg{
	#wintitle here is the tab that is highlighted (Not focused)
	my $wintitle = Xchat::get_info("channel");
	# exit, if he's already focused on this tab:
	return Xchat::EAT_NONE if (is_Active_Window($wintitle));

	# otherwise, he is on a query - give him a hint for the msg:
	my $channel = $wintitle;

	# from now on refer to the focused tab
	Xchat::set_context(Xchat::find_context());
	my $focused = Xchat::get_info("channel");
	return Xchat::EAT_NONE if (is_Script_Window($focused));

	my $type = $_[1];
	my $nick = $_[0][0];
	my $content = $_[0][1];

	my $output = "\00305\x{205E}\x{205E}\002\x{205E}\x{205E}\017\t";
	$output .= "\00304\002" . $nick . "\017 ";
	$output .= "\002\00316(\002\00304" .  $channel . "\00316\002)\002: ";
	if ($type =~ /me/){
		$output .= $nick . " ";
	}
	$output .= $content;

	Xchat::print($output);
	return Xchat::EAT_NONE;
}

